#!/usr/bin/ruby -Ku
# coding: utf-8
# $Id: generator.rb,v 1.4 2009/02/17 05:05:46 nishimoto Exp $
# (c) Takuya NISHIMOTO 

require 'erb'

class Generator
  attr_accessor :dry_run
  def translate(src)
    ERB.new(src, nil, '-').result(binding)
  end

  # skel_dir/file.txt -> target_dir/file
  def generate(skel_dir, file, target_dir)
    unless @dry_run
      begin
        str = File.open("#{skel_dir}/#{file}.txt").read
        #puts str
        File.open("#{target_dir}/#{file}", "w") do |f|
          f.write translate(str)
        end
      rescue => error
        puts error.message
        exit
      end
    end
    puts "#{target_dir}/#{file} generated."
  end
end
